package de.ivu.elect.presentation.kandidatur.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.kandidatur.boundary.ListenkandidaturEdit;
import de.ivu.elect.business.kandidatur.entity.Kandidatur;
import de.ivu.elect.business.kandidatur.entity.KandidaturStatus;
import de.ivu.elect.business.kandidatur.entity.Listenkandidatur;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.faces.FacesContextUtil;

public class NlWasKandidaturVerstorbenAction extends AbstractKandidaturAction {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient ListenkandidaturEdit listenkandidaturEdit;

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLVORSCHLAG_QS_ZULASSUNG_AENDERN_NACHTRAEGLICH_KEINE_ZULASSUNGSFAEHIGKEIT_NACH_ZULASSUNGSAUSSCHUSS;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Kandidatur kandidatur) {
    return !kandidatur.isZugelassen();
  }

  @Override
  public String doIt(Kandidatur kandidatur) {
    listenkandidaturEdit.setStatus(kandidatur.castTo(Listenkandidatur.class).getEntity(),
        KandidaturStatus.NICHT_MEHR_ZUGELASSEN_WEIL_ZULASSUNGSFAEHIGKEIT_NACH_ZULASSUNGSAUSSCHUSS_VERLOREN, "");

    return FacesContextUtil.getCurrentViewId();
  }

  @Override
  public String getLabelKey() {
    return "kandidatur.search.action.nicht.zulassen.da.zulassungsfaehigkeit.nach.zulassungsausschuss.verloren";
  }

  @Override
  public String getIcon() {
    return "fa fa-user-times";
  }


}
